myblog/views/auth.py
import functools

from flask import (
    Blueprint, render_template, request, redirect, url_for, flash, session, g
)

from werkzeug.security import check_password_hash, generate_password_hash

from myblog.models.db import db
from myblog.models.user import User

auth_bp = Blueprint('auth_bp', __name__, url_prefix='/auth')


@auth_bp.route('/register', methods=('GET', 'POST'))
def register():
    if request.method == 'POST':
        username = request.form['username']
        password = request.form['password']
        error = None

        if not username:
            error = 'Username is required.'
        elif not password:
            error = 'Password is required.'
        elif db.session.query(User). \
                filter(User.name == username). \
                first() is not None:
            error = f"User {username} is already registered."

        if error is None:
            user = User(
                name=username,
                password=generate_password_hash(password)
            )
            db.session.add(user)
            db.session.commit()
            return redirect(url_for('auth_bp.login'))

        flash(error)

    return render_template('auth/register.html')


@auth_bp.route('/login', methods=('GET', 'POST'))
def login():
    if request.method == 'POST':
        username = request.form['username']
        password = request.form['password']
        error = None
        user = db.session.query(User). \
            with_entities(User.id, User.name, User.password). \
            filter(User.name == username). \
            first()

        if user is None:
            error = 'Неверное имя пользователя.'
        elif not check_password_hash(user.password, password):
            error = 'Неверный пароль.'

        if error is None:
            session.clear()
            session['user_id'] = user.id
            return redirect(url_for('posts_bp.list'))

        flash(error)

    return render_template('auth/login.html')


@auth_bp.route('/logout')
def logout():
    session.clear()
    return redirect(url_for('posts_bp.list'))


@auth_bp.before_app_request
def load_logged_in_user():
    user_id = session.get('user_id')

    if user_id is None:
        g.user = None
    else:
        g.user = db.session.query(User). \
            filter(User.id == user_id). \
            first()


def login_required(view):
    @functools.wraps(view)
    def wrapped_view(**kwargs):
        if g.user is None:
            return redirect(url_for('auth_bp.login'))
        return view(**kwargs)
    return wrapped_view

myblog/templates/layout/default.html
<!doctype html>
<html lang="ru">

<head>

    <!--====== Required meta tags ======-->
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!--====== Title ======-->
    <title>{% block title %}{% endblock %}</title>

    <!--====== Favicon Icon ======-->
    <link rel="shortcut icon" href="{{ url_for('static', filename='images/favicon.ico') }}" type="image/ico">

    <!--====== Bootstrap css ======-->
    <link rel="stylesheet" href="{{ url_for('static', filename='css/bootstrap.min.css') }}">

    <!--====== Fontawesome css ======-->
    <link rel="stylesheet" href="{{ url_for('static', filename='css/all.css') }}">

    <!--====== animate css ======-->
    <link rel="stylesheet" href="{{ url_for('static', filename='css/animate.css') }}">

    <!--====== Magnific Popup css ======-->
    <link rel="stylesheet" href="{{ url_for('static', filename='css/magnific-popup.css') }}">

    <!--====== Slick css ======-->
    <link rel="stylesheet" href="{{ url_for('static', filename='css/slick.css') }}">

    <!--====== Default css ======-->
    <link rel="stylesheet" href="{{ url_for('static', filename='css/default.css') }}">

    <!--====== Style css ======-->
    <link rel="stylesheet" href="{{ url_for('static', filename='css/style.css') }}">


</head>

<body>

    <!--====== HEADER PART START ======-->

    <header class="header-area">
        <div class="header-nav">
            <div class="navigation">
                <nav class="navbar navbar-expand-lg navbar-light ">
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="toggler-icon"></span>
                        <span class="toggler-icon"></span>
                        <span class="toggler-icon"></span>
                    </button> <!-- navbar toggler -->

                    <div class="collapse navbar-collapse sub-menu-bar" id="navbarSupportedContent">
                        <ul class="navbar-nav">
                            {%- for endpoint, caption in [
                            ('posts_bp.list', 'Главная'),
                            ('gallery_bp.main', 'Галерея')
                            ] %}
                                <li class="nav-item">
                                    <a class="nav-link {% if endpoint == request.endpoint %}active{% endif %}" href={{ url_for(endpoint) }}>{{ caption }}</a>
                                </li>
                            {%- endfor %}
                        </ul>
                    </div> <!-- navbar collapse -->
                    <div class="navbar-social ">
                        <ul>
                            {% if g.user %}
                              <li><a href="{{ url_for('posts_bp.create') }}">Новый пост</a>
                              <li><a href="{{ url_for('auth_bp.logout') }}">Выйти из системы</a>
                            {% else %}
                              <li><a href="{{ url_for('auth_bp.login') }}">Войти в систему</a>
                            {% endif %}
                        </ul>
                    </div>
                </nav>
            </div> <!-- navigation -->
        </div>
    </header>

    <!--====== HEADER PART ENDS ======-->

    <!--====== PAGE TITLE PART START ======-->

    <section class="page-title-area bg_cover" style="background-image: url({{ url_for('static', filename='images/page-bg.jpg') }});">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-lg-12">
                    <div class="page-title-item text-center">
                        <h3 class="title">{% block page_title %}{% endblock %}</h3>
                    </div>
                </div>
            </div>
        </div>
    </section>

    <!--====== PAGE TITLE PART ENDS ======-->

    {% for message in get_flashed_messages() %}
        <div class="flash">{{ message }}</div>
    {% endfor %}

    <!--====== CONTENT PART START ======-->

    {% block content %}{% endblock %}

    <!--====== CONTENT PART ENDS ======-->

    <!--====== GO TO TOP PART START ======-->

    <div class="go-top-area">
        <div class="go-top-wrap">
            <div class="go-top-btn-wrap">
                <div class="go-top go-top-btn">
                    <i class="fa fa-angle-double-up"></i>
                    <i class="fa fa-angle-double-up"></i>
                </div>
            </div>
        </div>
    </div>

    <!--====== GO TO TOP PART ENDS ======-->



    <!--====== jquery js ======-->
    <script src="{{ url_for('static', filename='js/vendor/modernizr-3.6.0.min.js') }}"></script>
    <script src="{{ url_for('static', filename='js/vendor/jquery-1.12.4.min.js') }}"></script>

    <!--====== Bootstrap js ======-->
    <script src="{{ url_for('static', filename='js/bootstrap.min.js') }}"></script>
    <script src="{{ url_for('static', filename='js/popper.min.js') }}"></script>

    <!--====== Slick js ======-->
    <script src="{{ url_for('static', filename='js/slick.min.js') }}"></script>

    <!--====== Isotope js ======-->
    <script src="{{ url_for('static', filename='js/isotope.pkgd.min.js') }}"></script>

    <!--====== appear js ======-->
    <script src="{{ url_for('static', filename='js/jquery.appear.min.js') }}"></script>

    <!--====== counterup js ======-->
    <script src="{{ url_for('static', filename='js/jquery.counterup.min.js') }}"></script>

    <!--====== wow js ======-->
    <script src="{{ url_for('static', filename='js/wow.min.js') }}"></script>

    <!--====== circle progress js ======-->
    <script src="{{ url_for('static', filename='js/circle-progress.min.js') }}"></script>

    <!--====== waypoints js ======-->
    <script src="{{ url_for('static', filename='js/waypoints.min.js') }}"></script>

    <!--====== Images Loaded js ======-->
    <script src="{{ url_for('static', filename='js/imagesloaded.pkgd.min.js') }}"></script>

    <!--====== Magnific Popup js ======-->
    <script src="{{ url_for('static', filename='js/jquery.magnific-popup.min.js') }}"></script>

    <!--====== Ajax Contact js ======-->
    <script src="{{ url_for('static', filename='js/ajax-contact.js') }}"></script>

    <!--====== Main js ======-->
    <script src="{{ url_for('static', filename='js/main.js') }}"></script>

</body>

</html>